Bug 472643 - Accessibility: the Orca screenreader does not announce window names when switching through them. in Wayland session
Summary: Accessibility: the Orca screenreader does not announce window names when swit...
Status: RESOLVED FIXED
Alias: None
Product: kwin
Classification: Plasma
Component: tabbox (show other bugs)
Version: unspecified
Platform: Arch Linux Linux
: NOR normal
Target Milestone: ---
Assignee: KWin default assignee
URL:
Keywords: accessibility, wayland
Depends on:
Blocks:
 
Reported: 2023-07-26 03:59 UTC by Francesco Tissera
Modified: 2023-09-13 00:57 UTC (History)
3 users (show)

See Also:
Latest Commit:
Version Fixed In: 5.27.9


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Francesco Tissera 2023-07-26 03:59:49 UTC
SUMMARY
***
NOTE: If you are reporting a crash, please try to attach a backtrace with debug symbols.
See https://community.kde.org/Guidelines_and_HOWTOs/Debugging/How_to_create_useful_crash_reports
***
Tested this on Arch Linux, with plasma 5.27-6 and the last commit of Orca's master branch.
When pressing alt+tab to switch around windows, Orca does not announce window names in Plasma's wayland session. This bug does not accour on the X11 session so a lot of users work around the bug by using said session.

STEPS TO REPRODUCE
1. Log in to the Wayland session.

2. Turn on the screen reader and open some random applications.

3. navigate around the applications with alt+tab.

OBSERVED RESULT
Orca does not announce any window name/title when pressing alt+tab to navigate through them.

EXPECTED RESULT
The screenreader should speak window title/names.

SOFTWARE/OS VERSIONS
Linux/KDE Plasma: 
(available in About System)
Operating System: Arch Linux 
KDE Plasma Version: 5.27.6
KDE Frameworks Version: 5.108.0
Qt Version: 5.15.10
Kernel Version: 6.4.6-arch1-1 (64-bit)
Graphics Platform: X11
Processors: 8 × AMD Ryzen 7 4700U with Radeon Graphics
Memory: 15.0 GiB of RAM
Graphics Processor: AMD Radeon Graphics
Manufacturer: LENOVO
Product Name: 82FN
System Version: Yoga 6 13ARE05
Comment 1 Fushan Wen 2023-09-08 12:20:33 UTC
Does Orca ever work on Wayland?
Comment 2 Francesco Tissera 2023-09-08 15:15:19 UTC
Yeah, Orca works on Wayland, Gnome is a good example of that, plus KDE as well. The only thing, as far as I noticed anyway, that doesn't work is the windows not being announced when switching through them.
Comment 3 Fushan Wen 2023-09-08 16:58:33 UTC
Does the bug only occur on certain windows? When switching to Firefox, does Orca announce the window?
Comment 4 Fushan Wen 2023-09-08 17:31:10 UTC
If you mean the tabbox, I can also reproduce on X11.
Comment 5 Bug Janitor Service 2023-09-08 18:19:05 UTC
A possibly relevant merge request was started @ https://invent.kde.org/plasma/kdeplasma-addons/-/merge_requests/455
Comment 6 Bug Janitor Service 2023-09-09 02:41:55 UTC
A possibly relevant merge request was started @ https://invent.kde.org/plasma/plasma-workspace/-/merge_requests/3272
Comment 7 Bug Janitor Service 2023-09-09 02:50:01 UTC
A possibly relevant merge request was started @ https://invent.kde.org/plasma/kwin/-/merge_requests/4392
Comment 8 Bug Janitor Service 2023-09-09 02:58:21 UTC
A possibly relevant merge request was started @ https://invent.kde.org/plasma/kdeplasma-addons/-/merge_requests/456
Comment 9 Bug Janitor Service 2023-09-09 04:27:51 UTC
A possibly relevant merge request was started @ https://invent.kde.org/plasma/kwin/-/merge_requests/4393
Comment 10 Bug Janitor Service 2023-09-09 06:28:12 UTC
A possibly relevant merge request was started @ https://invent.kde.org/plasma/kwin/-/merge_requests/4394
Comment 11 Francesco Tissera 2023-09-09 06:58:01 UTC
When pressing alt+tab to switch through windows, no matter what the window is, Orca doesn't announce it.
On X11 this doesn't seem to happen however.
Comment 12 Fushan Wen 2023-09-09 13:50:51 UTC
Git commit f0c8a0c48214081a75242f16b8e5a87aced6ba38 by Fushan Wen.
Committed on 09/09/2023 at 15:31.
Pushed by fusionfuture into branch 'master'.

plugins/qpa: implement platform accessibility

This allows screen readers to read window titles in a tabbox.
FIXED-IN: 5.27.9

M  +11   -0    src/plugins/qpa/integration.cpp
M  +2    -0    src/plugins/qpa/integration.h

https://invent.kde.org/plasma/kwin/-/commit/f0c8a0c48214081a75242f16b8e5a87aced6ba38
Comment 13 Fushan Wen 2023-09-10 16:20:41 UTC
Git commit ce39bf7b62be7384aaba48f56651dbec4df5ba9a by Fushan Wen.
Committed on 09/09/2023 at 04:56.
Pushed by fusionfuture into branch 'master'.

windowswitchers/sidebar: fix missing focus in delegate

M  +1    -0    windowswitchers/sidebar/contents/ui/main.qml

https://invent.kde.org/plasma/kdeplasma-addons/-/commit/ce39bf7b62be7384aaba48f56651dbec4df5ba9a
Comment 14 Fushan Wen 2023-09-11 15:08:17 UTC
Git commit 14fb6ca6e39fe276089baf2b832832a087efb444 by Fushan Wen.
Committed on 09/09/2023 at 14:13.
Pushed by fusionfuture into branch 'Plasma/5.27'.

thumbnail_grid: allow screen reader to announce window name when pressing Alt+Tab

M  +5    -4    windowswitchers/thumbnail_grid/contents/ui/main.qml

https://invent.kde.org/plasma/kdeplasma-addons/-/commit/14fb6ca6e39fe276089baf2b832832a087efb444
Comment 15 Fushan Wen 2023-09-11 16:00:11 UTC
Git commit 6fc087180a843ed0f01f0b77a7c029cdaec15acd by Fushan Wen.
Committed on 11/09/2023 at 17:58.
Pushed by fusionfuture into branch 'Plasma/5.27'.

WindowSwitcher: move accessible properties to delegate root

M  +4    -4    lookandfeel/org.kde.breeze/contents/windowswitcher/WindowSwitcher.qml

https://invent.kde.org/plasma/plasma-workspace/-/commit/6fc087180a843ed0f01f0b77a7c029cdaec15acd
Comment 16 Fushan Wen 2023-09-11 16:09:11 UTC
Git commit 463c18f9fafefb49c22394a43886c32cacf39ab7 by Fushan Wen.
Committed on 11/09/2023 at 17:59.
Pushed by fusionfuture into branch 'master'.

thumbnail_grid: allow screen reader to announce window name when pressing Alt+Tab

M  +8    -5    src/tabbox/switchers/thumbnail_grid/contents/ui/main.qml

https://invent.kde.org/plasma/kwin/-/commit/463c18f9fafefb49c22394a43886c32cacf39ab7
Comment 17 Fushan Wen 2023-09-13 00:57:12 UTC
Git commit 17beab21aa7a15a8aab63d294df9f1af34d008fb by Fushan Wen.
Committed on 13/09/2023 at 02:47.
Pushed by fusionfuture into branch 'Plasma/5.27'.

plugins/qpa: implement platform accessibility

This allows screen readers to read window titles in a tabbox.
FIXED-IN: 5.27.9

(cherry picked from commit f0c8a0c48214081a75242f16b8e5a87aced6ba38)

M  +2    -0    CMakeLists.txt
M  +1    -0    src/plugins/qpa/CMakeLists.txt
M  +11   -0    src/plugins/qpa/integration.cpp
M  +2    -0    src/plugins/qpa/integration.h

https://invent.kde.org/plasma/kwin/-/commit/17beab21aa7a15a8aab63d294df9f1af34d008fb